
include windows.inc
include kernel32.inc
include user32.inc
include Comctl32.inc
include shell32.inc
include gdi32.inc

includelib kernel32.lib
includelib user32.lib
includelib Comctl32.lib
includelib shell32.lib
includelib gdi32.lib

DlgProc			PROTO
SerialCheck	PROTO
ROUTINESERIAL		PROTO
ROUTINENAME		PROTO

.const

IDD_DIALOG1			equ 101

;#########################################################################

.data?

hInstance			dd ?

;#########################################################################


oxAdd MACRO src, dest			; Incrmente la variable X fois
LOCAL boucle	
	Push ecx
	Mov ecx, src
	Push dest
boucle:	
	Inc Dword PTR [esp]
	Loop boucle
	Pop dest
	Pop ecx
endm

oxSub MACRO src, dest			; Dcrmente la variable X fois
LOCAL boucle	
	Push ecx
	Mov ecx, src
	Push dest
boucle:	
	Dec Dword PTR [esp]
	Loop boucle
	Pop dest
	Pop ecx
endm

oxJmp MACRO dest				; Place l'adresse sur la pile puis le RET saute dessus
	Push dest+0ABCDEF0h
	Sub Dword Ptr [esp], 0ABCDEF0h
	Ret
endm

oxRet MACRO val					; Enlve l'adresse de la pile puis saute dessus
	Add esp, val+4
	Jmp Dword PTR [esp-4-val]
	DB 68h						; inutile
endm

oxCall MACRO dest				; Appel d'une API
	Mov eax, dest+029Ch			; Rcupre l'adresse de l'api dans la table des Labels
	Mov eax, dword ptr [eax-029Ah]
	Push $+9					; Place l'adresse de retour sur la pile
	Jmp Dword Ptr [eax]			; Saute sur l'adresse de l'API
	Je $+15						; inutile
endm

oxCallF MACRO dest				; Appel d'une Fonction
	Push $+20					; Place l'adresse de retour sur la pile
	oxJmp dest					; Saute sur l'adresse de la fonction
	DW 7381h					; inutile
endm

oxPush MACRO val
	Sub esp, 4					; Ajoute un DWORD sur la pile
	Push esi
	Mov esi, val+401337h		; Crypte la valeur
	Mov Dword Ptr [esp+4], esi	; Place la valeur sur la pile
	Pop esi
	Sub Dword Ptr [esp], 401337h; Dcrypte la valeur
endm

oxMov MACRO dest, src			; Place src dans dest en passant par la pile
	Push src
	Pop dest
endm

oxCmp MACRO var1, var2			; Soustrait les 2 DWORD
	Mov eax, var1
	Mov ecx, var2
	Sub eax, ecx				; SUB modifie les Flags
endm

oxCmpw MACRO var1, var2			; Soustrait les 2 WORD
	Mov ax, var1
	Mov cx, var2
	Sub ax, cx
endm

oxCmpb MACRO var1, var2			; Soustrait les 2 BYTE
	Mov al, var1
	Mov cl, var2
	Sub al, cl
endm

oxJe MACRO dest					
	Lahf						; Rcupre les Flags dans AH
	And Ah, 40h					; Teste ZF (modifi par le SUB du CMP)
	Movzx ecx, ah
	jecxz $+4
	jmp dest	
endm

oxJne MACRO dest
	Lahf					
	And Ah, 40h				
	Movzx ecx, ah
	jecxz $+4
	jmp $+4
	jmp dest	
endm

oxJnef MACRO dest
	Lahf
	And Ah, 40h
	Movzx ecx, ah
	jecxz $+4
	jmp $+7
	jmp dest	
endm
